(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: SERIDCAS.PAS                                                   *)
(*  Obsah: program na automaticke serizovani hodin pocitace                *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*         Inspirovano programem AdjTime 1.0 / Michael Cowan, 1995         *)
(*  Posledni uprava: 18.4.2020                                             *)
(*  Pro kompilaci: DOS, RETEZCE                                            *)
(*  Pro spusteni: nic / SERIDCAS.CFG (vytvari se automaticky)              *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

{Pokud se vam v pocitaci predbihaji nebo zpozduji hodiny:
1) Zmerte si, kolik vterin za kolik dni to dela.
2) Napiste to do konfiguracniho souboru tohoto programku (podrobnosti jsou
   v napovede, kterou program zobrazi pri prvnim spusteni nebo se zadanym
   parametrem /?).
3) Cas od casu program spustte (nejlepsi je pridat si ho do AUTOEXEC.BAT, aby
   se spoustel automaticky). Bude vam posouvat hodiny tak, aby zadanou
   odchylku priblizne kompenzoval.
 Mate-li pocitac pripojeny na internet a vas operacni system si umi serizovat
hodiny automaticky podle centralniho serveru, tenhle program nepotrebujete.

Dalsi podrobnosti:
 K posunu hodin dochazi maximalne jednou za zadany pocet dnu, ne casteji.
Opakovane spusteni ve stejny den nevadi, program jenom probehne naprazdno a
nic neudela.
 Presne zlomky dnu se neresi - neni to potreba.
 Pokud mezi dvema spustenimi programu ubehne vice dnu nez kolik bylo zadano,
zohledni se to.
 Pokud by casovy posun vysel pres pulnoc, zarazi se o ni, datum se
nemeni (to je sice chyba, ale pravdepodobnost, ze nahodou zapnu pocitac par
vterin po pulnoci zrovna v den, kdy se maji serizovat hodiny, je natolik mala,
ze mi oprava nestoji za namahu).

 K napsani tohohle programu me inspiroval program AdjTime, ktery vysel pred
mnoha lety na CD Kouzelna dilna a dela vicemene totez, jenom si datum
posledniho serizeni uklada primo do sveho COM souboru a pozadovany posun ve
vterinach za den se mu zadava pres parametr, coz mi pripada trochu nesikovne.
Proto jsem si napsal tenhle klon. A taky proto, ze opensource je lepsi nez
shareware :-).}

program Serizovac_hodin;
{$I-}
uses dos,retezce;

var PocetVterin,PocetDnu:integer;{zadane serizovaci konstanty}
    AktualniRok,AktualniMesic,AktualniDen,{dnesni datum}
    MinulyRok,MinulyMesic,MinulyDen,{datum minuleho serizeni}
    PuvodniHodiny,PuvodniMinuty,PuvodniVteriny,PuvodniSetiny,{co ukazuji hodiny}
    NoveHodiny,NoveMinuty,NoveVteriny,NoveSetiny,{co by mely ukazovat}
    UbehleDny,{pocet dnu od posledniho serizeni}
    w:word;{pomocna}
    PuvodniAbsSetiny,NoveAbsSetiny:longint;{absolutni cas v setinach vteriny od pulnoci}
    s:string;{pro rozebirani parametru}
    soubor:text;{na ukladani data posledniho serizeni}

const PoctyDnu:array[1..12] of integer=(0,31,59,90,120,151,181,212,243,273,304,334);
               {soucty poctu dnu ve vsech mesicich pred timto}
      MaxSetiny=100*60*60*24-1;{23:59:59.99}

function AbsDatum(rok,mesic,den:word):longint; {vraci datum prepocitane na dny}
var prestup:word; {1, kdyz je prestupny rok, jinak 0}
    CisloDne:word; {kolikaty den v roce je (1..365 nebo 366)}
Begin
{urceni, jestli je prestupny rok:}
if (rok mod 4)<>0 then prestup:=0
 else if (rok mod 100)<>0 then prestup:=1
  else if (rok mod 400)<>0 then prestup:=0
   else prestup:=1;
cislodne:=PoctyDnu[mesic]+den;
if cislodne>poctydnu[2]+28 then cislodne:=cislodne+prestup;
absdatum:=longint(365)*rok+cislodne;{prestupnost predchozich roku neresim}
End;{absdatum}

function UlozHodnoty(vteriny,dny:integer; rok,mesic,den:word):boolean; {vraci true pri uspechu}
Begin
rewrite(soubor);
writeln(soubor,'Pozadovany posun hodin (vteriny/dny):');
writeln(soubor,vteriny);
writeln(soubor,dny);
writeln(soubor,'Datum posledniho serizeni hodin (den/mesic/rok):');
writeln(soubor,den);
writeln(soubor,mesic);
writeln(soubor,rok);
close(soubor);
if ioresult<>0 then begin
                    writeln('*** Pozor, chyba: nelze zapisovat do souboru SERIDCAS.CFG!');
                    ulozhodnoty:=false;
                    end
               else ulozhodnoty:=true;
End;{ulozhodnoty}

procedure VypisNapovedu;
Begin
writeln(' V adresari s programem najdete konfiguracni soubor SERIDCAS.CFG.');
writeln('Tento soubor otevrete pomoci libovolneho textoveho editoru a na druhy');
writeln('a treti radek napiste, o kolik vterin za kolik dnu chcete hodiny posouvat.');
writeln('Napr. kdyz vite, ze se vam hodiny predbihaji o 2 vteriny za tyden, zadejte');
writeln('na druhy radek -2 a na treti 7 (ubrat 2 s za 7 dni). Nebo kdyz se opozduji');
writeln('o vterinu za tri dny, zadejte +1 a 3 (plus se muze vynechat). Zadavejte');
writeln('pouze cela cisla.');
writeln(' Na posledni tri radky si program uklada informaci o tom, kdy hodiny');
writeln('naposledy serizoval. Za normalnich okolnosti na tato cisla nesahejte.');
writeln('V pripade potreby muzete vynulovanim nektereho z nich vyvolat reset (program');
writeln('si poznamena, ze naposledy serizoval cas dneska, ale nic ted serizovat nebude).');
writeln('Zadanim starsiho data vyvolate nove serizeni (pozor, ze delka posunu zavisi');
writeln('na tom, jak stare to datum je), zadanim novejsiho data odlozite pristi');
writeln('serizeni.');
writeln;
writeln(' Program ukoncite stisknutim Enteru.');
readln;
End;{vypisnapovedu}

BEGIN
writeln;
writeln('=== Serizovac hodin ===                    / Mircosoft 2020');
writeln;
if (paramcount>0)and(paramstr(1)='/?') then begin
                                            vypisnapovedu;
                                            halt;
                                            end;

{nacteni serizovacich konstant a data minuleho serizeni:}
pocetvterin:=0; pocetdnu:=0;
minulyrok:=0; minulymesic:=0; minulyden:=0;
assign(soubor,'SERIDCAS.CFG');
reset(soubor);
readln(soubor);
readln(soubor,pocetvterin);
readln(soubor,pocetdnu);
readln(soubor);
readln(soubor,minulyden);
readln(soubor,minulymesic);
readln(soubor,minulyrok);
close(soubor);
if ioresult<>0 then {neco se nenacetlo a zustalo to nulove};

{osetreni pripadnych nesmyslu v nactenych hodnotach:}
if pocetdnu<0 then pocetdnu:=-pocetdnu;
if minulyden>31 then minulyden:=0;
if minulymesic>12 then minulymesic:=0;
{rok muze byt teoreticky libovolny}

{neni-li zadany casovy posun, ulozime same nuly, vypiseme napovedu a koncime:}
if (pocetvterin=0)or(pocetdnu=0)
  then begin
       if ulozhodnoty(pocetvterin,pocetdnu,0,0,0) then vypisnapovedu;
       halt;
       end
  else writeln('Pozadovane serizeni: ',pocetvterin,' s za ',pocetdnu,' ',vysklonuj(pocetdnu,'den','dny','dnu'),'.');

{jestli jsme jeste tady, tak je casovy posun zadany}

{kolikateho dneska je:}
getdate(aktualnirok,aktualnimesic,aktualniden,w);

{jestli je v datu minuleho serizeni nula, nastavime ho na dnesek,
ulozime a koncime:}
write('Datum posledniho serizeni: ');
if (minulyrok=0)or(minulymesic=0)or(minulyden=0)
  then begin
       writeln('neni nastaveno, ukladam dnesni datum.');
       if ulozhodnoty(pocetvterin,pocetdnu,aktualnirok,aktualnimesic,aktualniden) then {hm};
       halt;
       end
  else writeln(minulyden,'. ',minulymesic,'. ',minulyrok);

{jestli jsme jeste tady, tak mame zadany platny casovy posun
i datum minuleho serizeni}

writeln('Dnesni datum: ',aktualniden,'. ',aktualnimesic,'. ',aktualnirok);

{kolik dnu ubehlo od posledniho serizeni:}
ubehledny:=absdatum(aktualnirok,aktualnimesic,aktualniden)-absdatum(minulyrok,minulymesic,minulyden);
write('Od posledniho serizeni ubehl',vysklonuj(ubehledny,'','y','o'),' ',
      ubehledny,' ',vysklonuj(ubehledny,'den','dny','dnu'),', ');
if ubehledny<pocetdnu
  then begin
       writeln('nove serizeni zatim neni potreba.');
       {a nemusime ani nic ukladat}
       halt;
       end
  else begin
       writeln('to uz stoji za nove serizeni.');
       {ulozime dnesek jako datum posledniho serizeni:}
       if not ulozhodnoty(pocetvterin,pocetdnu,aktualnirok,aktualnimesic,aktualniden)
         then halt;{musime zabranit opakovanemu serizovani se stejnym datem}
       {kolik je hodin:}
       gettime(puvodnihodiny,puvodniminuty,puvodnivteriny,puvodnisetiny);
       puvodniabssetiny:=((puvodnihodiny*longint(60)+puvodniminuty)*60+puvodnivteriny)*100+puvodnisetiny;
       {kolik hodin ma byt:}              {^^^pretypovani na longint je nutne, jinak to preteka}
       noveabssetiny:=puvodniabssetiny+(longint(100)*pocetvterin*ubehledny) div pocetdnu;
       {nechce se mi resit posouvani data, tak radsi jenom oriznu cas
       do rozsahu jednoho dne a budu doufat, ze program nikdo nebude
       spoustet okolo pulnoci:}
       if noveabssetiny<0 then noveabssetiny:=0
        else if noveabssetiny>maxsetiny then noveabssetiny:=maxsetiny;
       {prepocet ze setin na hodiny, minuty, vteriny a setiny:}
       novesetiny:=noveabssetiny mod 100;
       noveabssetiny:=noveabssetiny div 100;
       novevteriny:=noveabssetiny mod 60;
       noveabssetiny:=noveabssetiny div 60;
       noveminuty:=noveabssetiny mod 60;
       noveabssetiny:=noveabssetiny div 60;
       novehodiny:=noveabssetiny;
       noveabssetiny:=0;
       {a konecne posuneme ty hodiny:}
       settime(novehodiny,noveminuty,novevteriny,novesetiny);
       writeln('Cas posunut z ',
               puvodnihodiny,':',nastr3(puvodniminuty,2),':',nastr3(puvodnivteriny,2),'.',nastr3(puvodnisetiny,2),
               ' na ',
               novehodiny,':',nastr3(noveminuty,2),':',nastr3(novevteriny,2),'.',nastr3(novesetiny,2));
       end;
END.